=begin
#Platform external API.

#Documentation of our Platform external API.

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.34
=end

module Shippo
  class RefundsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a refund
    # Creates a new refund object.
    # @param merchant_id description: Object ID of the merchant
    # @param [Hash] opts the optional parameters
    # @option opts [RefundRequestBody] :body Refund details
    # @option opts [String] :shippo_api_version description: String used to pick a non-default api version to use
    # @return [Refund]
    def create_refund(merchant_id, opts = {})
      data, _status_code, _headers = create_refund_with_http_info(merchant_id, opts)
      data
    end

    # Create a refund
    # Creates a new refund object.
    # @param merchant_id description: Object ID of the merchant
    # @param [Hash] opts the optional parameters
    # @option opts [RefundRequestBody] :body Refund details
    # @option opts [String] :shippo_api_version description: String used to pick a non-default api version to use
    # @return [Array<(Refund, Integer, Hash)>] Refund data, response status code and response headers
    def create_refund_with_http_info(merchant_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RefundsApi.create_refund ...'
      end
      # verify the required parameter 'merchant_id' is set
      if @api_client.config.client_side_validation && merchant_id.nil?
        fail ArgumentError, "Missing the required parameter 'merchant_id' when calling RefundsApi.create_refund"
      end
      # resource path
      local_var_path = '/merchants/{MerchantId}/refunds/'.sub('{' + 'MerchantId' + '}', merchant_id.to_s)

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])
      header_params[:'SHIPPO-API-VERSION'] = opts[:'shippo_api_version'] if !opts[:'shippo_api_version'].nil?

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(opts[:'body']) 

      return_type = opts[:return_type] || 'Refund' 

      auth_names = opts[:auth_names] || ['APIKeyHeader']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RefundsApi#create_refund\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Retrieve a refund
    # Retrieve an existing refund by object id.
    # @param merchant_id description: Object ID of the merchant
    # @param refund_id description: Object ID of the refund to update
    # @param [Hash] opts the optional parameters
    # @option opts [String] :shippo_api_version description: String used to pick a non-default api version to use
    # @return [Refund]
    def get_refund(merchant_id, refund_id, opts = {})
      data, _status_code, _headers = get_refund_with_http_info(merchant_id, refund_id, opts)
      data
    end

    # Retrieve a refund
    # Retrieve an existing refund by object id.
    # @param merchant_id description: Object ID of the merchant
    # @param refund_id description: Object ID of the refund to update
    # @param [Hash] opts the optional parameters
    # @option opts [String] :shippo_api_version description: String used to pick a non-default api version to use
    # @return [Array<(Refund, Integer, Hash)>] Refund data, response status code and response headers
    def get_refund_with_http_info(merchant_id, refund_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RefundsApi.get_refund ...'
      end
      # verify the required parameter 'merchant_id' is set
      if @api_client.config.client_side_validation && merchant_id.nil?
        fail ArgumentError, "Missing the required parameter 'merchant_id' when calling RefundsApi.get_refund"
      end
      # verify the required parameter 'refund_id' is set
      if @api_client.config.client_side_validation && refund_id.nil?
        fail ArgumentError, "Missing the required parameter 'refund_id' when calling RefundsApi.get_refund"
      end
      # resource path
      local_var_path = '/merchants/{MerchantId}/refunds/{RefundId}/'.sub('{' + 'MerchantId' + '}', merchant_id.to_s).sub('{' + 'RefundId' + '}', refund_id.to_s)

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      header_params[:'SHIPPO-API-VERSION'] = opts[:'shippo_api_version'] if !opts[:'shippo_api_version'].nil?

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Refund' 

      auth_names = opts[:auth_names] || ['APIKeyHeader']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RefundsApi#get_refund\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
